MisDirectionHelperLDB = LibStub("AceAddon-3.0"):NewAddon("MisDirectionHelperLDB", "AceEvent-3.0", "LibSink-2.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MisDirectionHelper",true)
local QTC = LibStub('LibQTipClick-1.1')
local icon =  LibStub("LibDBIcon-1.0")

local addon = MisDirectionHelperLDB
local MDHText = "MDH"
local channels = {["RAID"] = "Raid", ["PARTY"] = "Party", ["WHISPER"] = "Whisper"}

local function set(info, value)
		local key = info[#info] 
		addon.db.profile[key] = value		
end

local function get(info)
		local key = info[#info] 
		return addon.db.profile[key]
end

local optionsTable = {
	handler = addon,
	type = 'group',
	desc = "MisDirectionHelper",
	args = {
		basicDesc = {
			order = 1,
			type = 'description',
			name = "MisDirectionHelper Options",
		},	
		showMinimapIcon = {
			order = 2,
			type = 'toggle',
			name = "Minimap Icon",
			desc = "Toggle Minimap icon.",
			get = function() return not addon.db.profile.LibDBIcon.hide end,
			set = function(_, v)
				addon.db.profile.LibDBIcon.hide = not v
				if v then
					icon:Show("MisDirectionHelper")
				else
					icon:Hide("MisDirectionHelper")
				end
			end,
		},		
		combatText = {
			order = 3,
			type = 'toggle',
			name = "Combat Text",
			desc = "Toggle Scrolling CombatText Support",
			get = function() return addon.db.profile.Combattext end,
			set = function(_, v)
				addon.db.profile.Combattext = v		
			end,
		},
		buffmessage = {
			order = 4,
			type = 'toggle',
			name = "Buff Messages",
			desc = "Toggle Misdirection Applied Announcing",
			get = function() return addon.db.profile.ChattextStart end,
			set = function(_, v)
				addon.db.profile.ChattextStart = v		
			end,
		},
		fademessage = {
			order = 5,
			type = 'toggle',
			name = "Fade Messages",
			desc = "Toggle Misdirection Fade Announcing",
			get = function() return addon.db.profile.ChattextEnd end,
			set = function(_, v)
				addon.db.profile.ChattextEnd = v		
			end,
		},
--		cooldownmessage = {
--			order = 6,
--			type = 'toggle',
--			name = "Cooldown Messages",
--			desc = "Toggle Misdirection Cooldown Announcing",
--			get = function() return addon.db.profile.Cooldowntext end,
--			set = function(_, v)
--				addon.db.profile.Cooldowntext = v		
--			end,
--		},
		chatraidonly = {
			order = 7,
			type = 'toggle',
			name = "Raid Only",
			desc = "Toggle Announcing Messages when in a Raid only",
			get = function() return addon.db.profile.ChatRaidOnly end,
			set = function(_, v)
				addon.db.profile.ChatRaidOnly = v		
			end,
		},
		chatChannelM = {
		  type = 'select',
		  name = "Buff OutPut Channel",
		  desc = "Select Channel for Buff Announcements",
		  order = 8,
		  get = get,
		  set = set,
		  values = channels,
		  arg = "chatChannelM",
	  },	  
--	  chatChanneCD = {
--		  type = 'select',
--		  name = "CoolDown OutPut Channel",
--		  desc = "Select Channel for CoolDown Announcements",
--		  order = 9,
--		  get = get,
--		  set = set,
--		  values = channels,
--		  arg = "chatChannelCD",
--	  },
    Output = addon:GetSinkAce3OptionsDataTable(),
	},	
}

local defaults = {
	profile = {
		LibDBIcon = { hide = false },
		chatChannelM = "PARTY",
		chatChannelCD = "PARTY",
		Name = "",
	  Petname = L["unknown"],
	  Combattext = true,
	  ChattextStart = false,
	  ChattextEnd = true,
	  Cooldowntext = false,
	  ChatRaidOnly = false,
		SinkOptions = {}	
	},	
}

--Create the data broker
MisDirectionHelperLDB.dataObject = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("MisDirectionHelper", {
	  type = "data source",
	  text = MDHText,
    icon = "Interface\\Icons\\Ability_Hunter_Misdirection",
    OnClick = function(frame, button)
				if button == "RightButton" then
				   InterfaceOptionsFrame_OpenToCategory(addon.optionsFrame)
			  elseif button == "LeftButton" then
	         addon:PlyrTarg()
				end
			end,
		OnEnter = function(frame)
				tooltip = QTC:Acquire("Broker_MisDirectionHelperTooltip", 1, "CENTER")
				tooltip:SmartAnchorTo(frame)
				tooltip:SetAutoHideDelay(0.25, frame)
				addon:ShowToolTip()
			end,
		OnLeave = function()
				return
			end,
})

local function HandlerFunc(event, cell, arg, button)
   local btn
    if arg == "b1" then
       addon:PrtyTank()
    elseif arg == "b2" then
       addon:PlyrTarg()
    elseif arg == "b3" then
       addon:ToT()
    elseif arg == "b4" then
       addon:PlyrPet()
    elseif arg == "b5" then
       addon:PopUp()
    elseif arg == "b6" then
       InterfaceOptionsFrame_OpenToCategory(addon.optionsFrame)
    end 
end

function addon:ShowToolTip()
    tooltip:Clear()
    tooltip:SetCallback("OnMouseDown", HandlerFunc)
    local headerFont = CreateFont("MisDirectionHelperHeaderFont")
	  MisDirectionHelperHeaderFont:CopyFontObject(GameTooltipHeaderText)
	  MisDirectionHelperHeaderFont:SetFont(MisDirectionHelperHeaderFont:GetFont(), 15)
    local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "|cffffff00MisDirectionHelper|r",MisDirectionHelperHeaderFont, "CENTER", 1)
    tooltip:SetLineColor(1, 1, 0, 1, 1)
    local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(2, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
    tooltip:SetLineColor(3, 0, 0, 1, 1)
    local y, x = tooltip:AddLine()
    y, x = tooltip:SetCell(y, 1, " Set To Party Tank", "b1")
    tooltip:SetLineColor(4, 1, 0, 0, 1)
    local y, x = tooltip:AddLine()
    y, x = tooltip:SetCell(y, 1, " Set To Target", "b2")
    tooltip:SetLineColor(5, 1, 0, 0, 1)
    local y, x = tooltip:AddLine()
    y, x = tooltip:SetCell(y, 1, " Set to TargetOfTarget", "b3")
    tooltip:SetLineColor(6, 1, 0, 0, 1)
    local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(7, 0, 0, 1, 1)
    local y, x = tooltip:AddLine()
    y, x = tooltip:SetCell(y, 1, " Set to Your Pet", "b4")
    tooltip:SetLineColor(8, 0, 1, 1, 1)
    local y, x = tooltip:AddLine()
    y, x = tooltip:SetCell(y, 1, " Enter Player Name", "b5")
	  tooltip:SetLineColor(9, 0, 1, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(10, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(11, 0, 0, 1, 1)
	  local y, x = tooltip:AddLine()
    y, x = tooltip:SetCell(y, 1, "MisDirectionHelper Options", "b6")
    tooltip:SetLineColor(12, 0, 1, 0, 1)
    local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(13, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(14, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "|cffffff00MDH is set to:|r|cffff0033 " .. addon:TTText(), "CENTER", 1)
	  tooltip:SetLineColor(15, 1, 0, 1, 0)
    local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(16, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "", "CENTER", 1)
	  tooltip:SetLineColor(17, 0, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "|cffffff00 Left Click Each Text To Activate|r ", "CENTER", 1)
	  tooltip:SetLineColor(18, 1, 0, 1, 1)
	  local y = tooltip:AddLine()
	  tooltip:SetNormalCell(y, 1, "|cffffff00Right Click For MDH Options|r", "CENTER", 1)
    tooltip:SetLineColor(19, 1, 0, 1, 1)
    if (InCombatLockdown()) then return end
    tooltip:Show()
end

function addon:MDHTextUpdate()
	 if addon.db.profile.Name == "" then
	   MisDirectionHelperLDB.dataObject.text = (MDHText)
	 else
	   MisDirectionHelperLDB.dataObject.text = (addon.db.profile.Name)
	 end
end

function addon:PlyrTarg()
   addon:MDHtarget();
	 addon:MDHEditMacro();
end

function addon:ToT()
	addon.db.profile.Name = "targettarget"; 
	addon:MDHEditMacro();
end

function addon:PlyrPet()
		if (UnitExists("pet")) then
			 addon:MDHgetpet();
		end
		addon.db.profile.Name = addon.db.profile.Petname;
		addon:MDHEditMacro();
end

function addon:PrtyTank()
	 addon:MDHtank();
	 addon:MDHEditMacro();
end

function addon:PopUp()
    StaticPopupDialogs["MDH_GET_PLAYER_NAME"] = {
			text = "Player to Misdirect to:", button1 = "OK", button2 = "Cancel", hasEditBox = 1,
			OnAccept = function()
				 if not (UnitAffectingCombat("player")) then
				   addon.db.profile.Name = getglobal(this:GetParent():GetName().."EditBox"):GetText().." "				 			       
		        if (addon.db.profile.Name == "Pet" or addon.db.profile.Name == "pet") then
			         addon.db.profile.Name = addon.db.profile.Petname;
		        elseif (addon.db.profile.Name == "Tank" or addon.db.profile.Name == "tank") then
			         addon:MHDtank();
		        elseif (addon.db.profile.Name == "Target" or addon.db.profile.Name == "target" or addon.db.profile.Name == "t")then
			         addon:MHDtarget();
		        end
		      addon:MDHEditMacro();
	       end
			end,
			timeout = 0, whileDead = 1, hideOnEscape = 1
		}
		StaticPopup_Show("MDH_GET_PLAYER_NAME");
		return
end

function addon:MDHLoad()
	if (UnitExists("pet")) then
		addon:MDHgetpet();
	end
  addon:MDHTextUpdate()
	mdhlasttime = 0;
	mdh_buff = 0;
end

function addon:MDHLogout()
end

function addon:MDHgetpet()
	petname = UnitName("pet");
--	peticonpath=GetPetIcon();
	if (petname == L["unknown"]) then
		petname = addon.db.profile.Petname;
	end
--	if (peticonpath) then
--	end
	addon.db.profile.Petname = petname;
end

function addon:MDHtarget()
	if(UnitExists("target")) then
		addon.db.profile.Name = UnitName("target")
	end
end

function addon:MDHtank()
	local NumParty=GetNumPartyMembers();
	local NumRaid=GetNumRaidMembers();
	local mdhealth = 0;
	local mdtank = addon.db.profile.Name
	if (0 < NumParty and NumRaid == 0) then
		for i=1, NumParty, 1 do
			_, class=UnitClass("party"..i);
			if ("WARRIOR" == class or "DRUID" == class or "DEATHKNIGHT" == class or "PALADIN" == class) then
				if (mdhealth < UnitHealth("party"..i)) then
					mdhealth = UnitHealth("party"..i);
					mdtank = UnitName("party"..i);
				end
			end				
		end
	elseif (0 < NumRaid) then
		for i=1, NumRaid, 1 do
			_, class=UnitClass("raid"..i);
			if ("WARRIOR" == class or "DRUID" == class or "DEATHKNIGHT" == class or "PALADIN" == class) then
				if (mdhealth < UnitHealth("raid"..i)) then
					mdhealth = UnitHealth("raid"..i);
					mdtank = UnitName("raid"..i);
				end
			end				
		end
	end
	addon.db.profile.Name = mdtank;
end

function addon:MDHEditMacro()
	addon:MDHTextUpdate()	
	
	if (addon.db.profile.Name == "targettarget") then
		 macro = string.format("#showtooltip %s\n/target targettarget\n/cast %s\n/targetlasttarget\n", L["misd"], L["misd"]);
	else
		 macro = string.format("#showtooltip %s\n/target %s\n/cast %s\n/targetlasttarget", L["misd"], addon.db.profile.Name, L["misd"]);
	end

	local macroid = GetMacroIndexByName(L["misd"]);
	if (macroid == 0) then
		CreateMacro(L["misd"] , 134, macro, 1, 1);
	else
		EditMacro(macroid, L["misd"] , 134, macro);
	end
end

function addon:MDHCombatText()	
	if addon.db.profile.Combattext then
		 if IsAddOnLoaded("Parrot") then
		   addon:MDHSinkMsg()
		 end
	end
end

function addon:MDHSinkMsg() 
	 combattext = L["displaytext1"]..misdtarget..L["displaytext2"];
   if addon.db.profile.Combattext then
		 if IsAddOnLoaded("Parrot") then
		    addon:Pour(combattext, "Notification", true, 0.5, 0.5, 1)
		  -- Parrot:ShowMessage(combattext, "Notification", true, 0.5, 0.5, 1)
		 end
	 else
		 UIErrorsFrame:AddMessage(combattext,.9,.2,.2,1,UIERRORS_HOLD_TIME)
	 end
end

function addon:MDHBuff()
	 mdh_buff = 1;
	 gdmg = 0;
end

function addon:MDHUnBuff()
	 mdh_buff = 0;
	  if (gdmg ~= 0) then
		  if (addon.db.profile.chatChannelM == "PARTY" and GetPartyMember(1)~=nil) then
			   SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."! ("..gdmg..")", addon.db.profile.chatChannelM ,nil ,addon.db.profile.Channel);
		  elseif (addon.db.profile.chatChannelM == "RAID" and GetNumRaidMembers()~= 0) then
			   SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."! ("..gdmg..")", addon.db.profile.chatChannelM ,nil ,addon.db.profile.Channel);
		  elseif (addon.db.profile.chatChannelM ~= "RAID" and addon.db.profile.chatChannelM ~= "PARTY" and addon.db.profile.chatChannelM ~= "WHISPER")  then
			   SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."! ("..gdmg..")", addon.db.profile.chatChannelM ,nil ,addon.db.profile.Channel);
		  elseif (addon.db.profile.chatChannelM == "WHISPER") then
			   SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."! ("..gdmg..")", addon.db.profile.chatChannelM, nil, misdtarget);
		  end
	 end
end

function addon:MDHChatDmg(arg12)
	 dmg = arg12;
	  if (dmg ~= nil) then
		  gdmg = gdmg + dmg;
	  end
end

function addon:MDHChatStart()
	if (addon.db.profile.chatChannelM == "PARTY" and GetNumPartyMembers()~=0) then
		SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."!", addon.db.profile.chatChannelM ,nil ,addon.db.profile.Channel);
	elseif (addon.db.profile.chatChannelM == "RAID" and GetNumRaidMembers()~= 0) then
		SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."!", addon.db.profile.chatChannelM ,nil ,addon.db.profile.Channel);
	elseif (addon.db.profile.chatChannelM == "WHISPER") then
		SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."!", addon.db.profile.chatChannelM ,nil ,misdtarget);
	elseif (addon.db.profile.chatChannelM ~= "RAID" and addon.db.profile.chatChannelM ~= "PARTY" and addon.db.profile.chatChannelM ~= "WHISPER") then
		SendChatMessage(L["displaytext1"]..misdtarget..L["displaytext2"].."!", addon.db.profile.chatChannelM ,nil ,addon.db.profile.Channel);
	end
end

function addon:OnInitialize()	
	 addon.db = LibStub("AceDB-3.0"):New("MisDirectionHelperDB", defaults)
	 optionsTable.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(addon.db)
	 LibStub("AceConfig-3.0"):RegisterOptionsTable("MisDirectionHelper", optionsTable)
	 addon.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("MisDirectionHelper", "MisDirectionHelper")
	
	 if icon then
		 icon:Register("MisDirectionHelper", MisDirectionHelperLDB.dataObject, addon.db.profile.LibDBIcon)		
	 end
	 self:SetSinkStorage(addon.db.profile.SinkOptions)
   addon:MDHOnload()
end

function addon:MDHOnload()
   addon:RegisterEvent('PLAYER_ENTERING_WORLD')
	 addon:RegisterEvent('UNIT_PET')
	 addon:RegisterEvent('PLAYER_LEAVING_WORLD')
	 addon:RegisterEvent('UNIT_SPELLCAST_SENT')
	 addon:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED')
	 addon:RegisterEvent('COMBAT_LOG_EVENT')
end

function addon:PLAYER_ENTERING_WORLD()
    addon:MDHLoad()
end

function addon:UNIT_PET()
    if arg1 == "player" and UnitExists("pet") then
       addon:MDHgetpet()
    end
end

function addon:PLAYER_LEAVING_WORLD()    
  --  addon:MDHlogout()    
end

function addon:UNIT_SPELLCAST_SENT()
    if (arg1 == "player" and arg2 == L["misd"]) then
			misdtarget = arg4;
			if (misdtarget ~= UnitName("player")) then
				addon.db.profile.timer = GetTime();
			end
		end
end

function addon:UNIT_SPELLCAST_SUCCEEDED()
    if (arg1 == "player" and arg2 == L["misd"]) then
			if (addon.db.profile.timer and GetTime() - addon.db.profile.timer < 20) then
				if (addon.db.profile.Combattext == "true") then
					 addon:MDHCombatText();
				end
				if (addon.db.profile.ChattextStart == "true") then
					if (addon.db.profile.ChatRaidOnly ~= "true" or GetNumRaidMembers()~= 0) then
						addon:MDHChatStart();
					end
				end
				if (addon.db.profile.ChattextEnd == "true") then
					if (addon.db.profile.ChatRaidOnly ~= "true" or GetNumRaidMembers()~= 0) then
						addon:MDHBuff();
					end
				end
			end
		end
end

function addon:COMBAT_LOG_EVENT()
    if ((arg2 == "SWING_DAMAGE" or arg2 == "RANGE_DAMAGE" or arg2 == "SPELL_DAMAGE") and arg4 == UnitName("player") and mdh_buff == 1) then			
			addon:MDHChatDmg(arg12);
		end
end

function addon:SPELL_AURA_REMOVED()
    if (addon.db.profile.ChattextEnd == "true") then
			if (addon.db.profile.ChatRaidOnly ~= "true" or GetNumRaidMembers()~= 0) then
				addon:MDHUnBuff();
			end
	  end
end

function addon:TTText()
  if addon.db.profile.Name == "" then
    return "No One"
  else
    return addon.db.profile.Name
  end
end